#include <stdio.h>

#if defined(WIN32)
# include <windows.h>
#endif

#define INCL_REXXSAA
#include <rexxtrans.h>

#define FUNCTION_REXXSTART                     0
#define FUNCTION_REXXREGISTEREXITEXE           1
#define FUNCTION_REXXREGISTEREXITDLL           2
#define FUNCTION_REXXDEREGISTEREXIT            3
#define FUNCTION_REXXQUERYEXIT                 4
#define FUNCTION_REXXREGISTERSUBCOMEXE         5
#define FUNCTION_REXXDEREGISTERSUBCOM          6
#define FUNCTION_REXXREGISTERSUBCOMDLL         7
#define FUNCTION_REXXQUERYSUBCOM               8
#define FUNCTION_REXXREGISTERFUNCTIONEXE       9
#define FUNCTION_REXXREGISTERFUNCTIONDLL      10
#define FUNCTION_REXXDEREGISTERFUNCTION       11
#define FUNCTION_REXXQUERYFUNCTION            12
#define FUNCTION_REXXVARIABLEPOOL             13
#define NUM_REXX_FUNCTIONS                    14


typedef struct
{
   char *Name;
   int  ObjectRexxAPI;
} MYFUNCTIONNAME;

static MYFUNCTIONNAME MyFunctionName[ NUM_REXX_FUNCTIONS ] =
{
   /*  0 */ {"RexxStart",                0 },
   /*  1 */ {"RexxRegisterExitExe",      1 },
   /*  2 */ {"RexxRegisterExitDll",      1 },
   /*  3 */ {"RexxDeregisterExit",       1 },
   /*  4 */ {"RexxQueryExit",            1 },
   /*  5 */ {"RexxRegisterSubcomExe",    1 },
   /*  6 */ {"RexxDeregisterSubcom",     1 },
   /*  7 */ {"RexxRegisterSubcomDll",    1 },
   /*  8 */ {"RexxQuerySubcom",          1 },
   /*  9 */ {"RexxRegisterFunctionExe",  1 },
   /* 10 */ {"RexxRegisterFunctionDll",  1 },
   /* 11 */ {"RexxDeregisterFunction",   1 },
   /* 12 */ {"RexxQueryFunction",        1 },
   /* 13 */ {"RexxVariablePool",         0 }
};

static char *MyLibraryName[] =
{
   "REGINA",        /* Regina */
   "REXX",          /* Object Rexx */
   "WREXX32",       /* Quercus */
   "RXREXX",        /* Enterprise */
   "RXX",           /* uni-REXX - not included as doesn't conform*/
   NULL
};

typedef HINSTANCE handle_type ;

/*
 * Typedefs for Regina
 */
typedef APIRET APIENTRY RREXXSTART(LONG,PRXSTRING,PSZ,PRXSTRING,PSZ,LONG,PRXSYSEXIT,PSHORT,PRXSTRING );
typedef APIRET APIENTRY RREXXREGISTEREXITEXE(PSZ,PFN,PUCHAR ) ;
typedef APIRET APIENTRY RREXXREGISTEREXITDLL(PSZ,PSZ,PSZ,PUCHAR,ULONG ) ;
typedef APIRET APIENTRY RREXXDEREGISTEREXIT(PSZ,PSZ ) ;
typedef APIRET APIENTRY RREXXQUERYEXIT(PSZ,PSZ,PUSHORT,PUCHAR ) ;
typedef APIRET APIENTRY RREXXREGISTERSUBCOMEXE(PSZ,PFN,PUCHAR ) ;
typedef APIRET APIENTRY RREXXDEREGISTERSUBCOM(PSZ,PSZ ) ;
typedef APIRET APIENTRY RREXXREGISTERSUBCOMDLL(PSZ,PSZ,PSZ,PUCHAR,ULONG ) ;
typedef APIRET APIENTRY RREXXQUERYSUBCOM(PSZ,PSZ,PUSHORT,PUCHAR ) ;
typedef APIRET APIENTRY RREXXREGISTERFUNCTIONEXE(PSZ,PFN ) ;
typedef APIRET APIENTRY RREXXREGISTERFUNCTIONDLL(PSZ,PSZ,PSZ ) ;
typedef APIRET APIENTRY RREXXDEREGISTERFUNCTION(PSZ) ;
typedef APIRET APIENTRY RREXXQUERYFUNCTION(PSZ) ;
typedef APIRET APIENTRY RREXXVARIABLEPOOL(PSHVBLOCK );
RREXXSTART               *RRexxStart=NULL;
RREXXREGISTEREXITEXE     *RRexxRegisterExitExe=NULL;
RREXXREGISTEREXITDLL     *RRexxRegisterExitDll=NULL;
RREXXDEREGISTEREXIT      *RRexxDeregisterExit=NULL;
RREXXQUERYEXIT           *RRexxQueryExit=NULL;
RREXXREGISTERSUBCOMEXE   *RRexxRegisterSubcomExe=NULL;
RREXXDEREGISTERSUBCOM    *RRexxDeregisterSubcom=NULL;
RREXXREGISTERSUBCOMDLL   *RRexxRegisterSubcomDll=NULL;
RREXXQUERYSUBCOM         *RRexxQuerySubcom=NULL;
RREXXREGISTERFUNCTIONEXE *RRexxRegisterFunctionExe=NULL;
RREXXREGISTERFUNCTIONDLL *RRexxRegisterFunctionDll=NULL;
RREXXDEREGISTERFUNCTION  *RRexxDeregisterFunction=NULL;
RREXXQUERYFUNCTION       *RRexxQueryFunction=NULL;
RREXXVARIABLEPOOL        *RRexxVariablePool=NULL;

/*
 * Typedefs for Object Rexx
 */
typedef APIRET APIENTRY OREXXSTART(LONG,PRXSTRING,PSZ,PRXSTRING,PSZ,LONG,PRXSYSEXIT,PSHORT,PRXSTRING );
typedef APIRET APIENTRY OREXXREGISTEREXITEXE(PSZ,PFN,PUCHAR ) ;
typedef APIRET APIENTRY OREXXREGISTEREXITDLL(PSZ,PSZ,PSZ,PUCHAR,ULONG ) ;
typedef APIRET APIENTRY OREXXDEREGISTEREXIT(PSZ,PSZ ) ;
typedef APIRET APIENTRY OREXXQUERYEXIT(PSZ,PSZ,PUSHORT,PUCHAR ) ;
typedef APIRET APIENTRY OREXXREGISTERSUBCOMEXE(PSZ,PFN,PUCHAR ) ;
typedef APIRET APIENTRY OREXXDEREGISTERSUBCOM(PSZ,PSZ ) ;
typedef APIRET APIENTRY OREXXREGISTERSUBCOMDLL(PSZ,PSZ,PSZ,PUCHAR,ULONG ) ;
typedef APIRET APIENTRY OREXXQUERYSUBCOM(PSZ,PSZ,PUSHORT,PUCHAR ) ;
typedef APIRET APIENTRY OREXXREGISTERFUNCTIONEXE(PSZ,PFN ) ;
typedef APIRET APIENTRY OREXXREGISTERFUNCTIONDLL(PSZ,PSZ,PSZ ) ;
typedef APIRET APIENTRY OREXXDEREGISTERFUNCTION(PSZ) ;
typedef APIRET APIENTRY OREXXQUERYFUNCTION(PSZ) ;
typedef APIRET APIENTRY OREXXVARIABLEPOOL(PSHVBLOCK );
OREXXSTART               *ORexxStart=NULL;
OREXXREGISTEREXITEXE     *ORexxRegisterExitExe=NULL;
OREXXREGISTEREXITDLL     *ORexxRegisterExitDll=NULL;
OREXXDEREGISTEREXIT      *ORexxDeregisterExit=NULL;
OREXXQUERYEXIT           *ORexxQueryExit=NULL;
OREXXREGISTERSUBCOMEXE   *ORexxRegisterSubcomExe=NULL;
OREXXDEREGISTERSUBCOM    *ORexxDeregisterSubcom=NULL;
OREXXREGISTERSUBCOMDLL   *ORexxRegisterSubcomDll=NULL;
OREXXQUERYSUBCOM         *ORexxQuerySubcom=NULL;
OREXXREGISTERFUNCTIONEXE *ORexxRegisterFunctionExe=NULL;
OREXXREGISTERFUNCTIONDLL *ORexxRegisterFunctionDll=NULL;
OREXXDEREGISTERFUNCTION  *ORexxDeregisterFunction=NULL;
OREXXQUERYFUNCTION       *ORexxQueryFunction=NULL;
OREXXVARIABLEPOOL        *ORexxVariablePool=NULL;

/*
 * Typedefs for Quercus
 */
typedef SHORT FAR *LPSHORT;
typedef LONG APIENTRY   QREXXSTART(int,PRXSTRING,LPCSTR,PRXSTRING,LPCSTR,int,PRXSYSEXIT,LPSHORT,PRXSTRING );
typedef APIRET APIENTRY QREXXREGISTEREXITEXE(LPCSTR,FARPROC,LPBYTE );
typedef APIRET APIENTRY QREXXREGISTEREXITDLL(LPCSTR,LPCSTR,LPCSTR,LPBYTE,UINT );
typedef APIRET APIENTRY QREXXDEREGISTEREXIT(LPCSTR,LPCSTR );
typedef APIRET APIENTRY QREXXQUERYEXIT(LPCSTR,LPCSTR,LPWORD,LPBYTE ) ;
typedef APIRET APIENTRY QREXXREGISTERSUBCOMDLL(LPCSTR,LPCSTR,LPCSTR,LPBYTE,UINT );
typedef APIRET APIENTRY QREXXREGISTERSUBCOMEXE(LPCSTR,FARPROC,LPBYTE );
typedef APIRET APIENTRY QREXXQUERYSUBCOM(LPCSTR,LPCSTR,LPWORD,LPBYTE );
typedef APIRET APIENTRY QREXXDEREGISTERSUBCOM(LPCSTR,LPCSTR );
typedef APIRET APIENTRY QREXXREGISTERFUNCTIONDLL(LPCSTR,LPCSTR,LPCSTR);
typedef APIRET APIENTRY QREXXREGISTERFUNCTIONEXE(LPCSTR,FARPROC );
typedef APIRET APIENTRY QREXXDEREGISTERFUNCTION(LPCSTR );
typedef APIRET APIENTRY QREXXQUERYFUNCTION(LPCSTR );
typedef APIRET APIENTRY QREXXVARIABLEPOOL(PSHVBLOCK );
QREXXSTART               *QRexxStart=NULL;
QREXXREGISTEREXITEXE     *QRexxRegisterExitExe=NULL;
QREXXREGISTEREXITDLL     *QRexxRegisterExitDll=NULL;
QREXXDEREGISTEREXIT      *QRexxDeregisterExit=NULL;
QREXXQUERYEXIT           *QRexxQueryExit=NULL;
QREXXREGISTERSUBCOMEXE   *QRexxRegisterSubcomExe=NULL;
QREXXDEREGISTERSUBCOM    *QRexxDeregisterSubcom=NULL;
QREXXREGISTERSUBCOMDLL   *QRexxRegisterSubcomDll=NULL;
QREXXQUERYSUBCOM         *QRexxQuerySubcom=NULL;
QREXXREGISTERFUNCTIONEXE *QRexxRegisterFunctionExe=NULL;
QREXXREGISTERFUNCTIONDLL *QRexxRegisterFunctionDll=NULL;
QREXXDEREGISTERFUNCTION  *QRexxDeregisterFunction=NULL;
QREXXQUERYFUNCTION       *QRexxQueryFunction=NULL;
QREXXVARIABLEPOOL        *QRexxVariablePool=NULL;

/*
 * Typedefs for Enterprise
 */
typedef int APIENTRY    WREXXSTART(int,PRXSTRING,LPCSTR,PRXSTRING,LPCSTR,int,PRXSYSEXIT,LPSHORT,PRXSTRING );
typedef APIRET APIENTRY WREXXREGISTEREXITDLL(LPCSTR,LPCSTR,LPCSTR,LPBYTE,UINT );
typedef APIRET APIENTRY WREXXREGISTEREXITEXE(LPCSTR,FARPROC,LPBYTE );
typedef APIRET APIENTRY WREXXDEREGISTEREXIT(LPCSTR,LPCSTR ) ;
typedef APIRET APIENTRY WREXXQUERYEXIT(LPCSTR,LPCSTR,LPWORD,LPBYTE ) ;
typedef APIRET APIENTRY WREXXREGISTERSUBCOMDLL(LPCSTR,LPCSTR,LPCSTR,LPBYTE,UINT );
typedef APIRET APIENTRY WREXXREGISTERSUBCOMEXE(LPCSTR,FARPROC,LPBYTE );
typedef APIRET APIENTRY WREXXQUERYSUBCOM(LPCSTR,LPCSTR,LPWORD,LPBYTE );
typedef APIRET APIENTRY WREXXDEREGISTERSUBCOM(LPCSTR,LPCSTR );
typedef APIRET APIENTRY WREXXREGISTERFUNCTIONDLL(LPCSTR,LPCSTR,LPCSTR);
typedef APIRET APIENTRY WREXXREGISTERFUNCTIONEXE(LPCSTR,FARPROC );
typedef APIRET APIENTRY WREXXDEREGISTERFUNCTION(LPCSTR );
typedef APIRET APIENTRY WREXXQUERYFUNCTION(LPCSTR );
typedef APIRET APIENTRY WREXXVARIABLEPOOL(PSHVBLOCK );
WREXXSTART               *WRexxStart=NULL;
WREXXREGISTEREXITEXE     *WRexxRegisterExitExe=NULL;
WREXXREGISTEREXITDLL     *WRexxRegisterExitDll=NULL;
WREXXDEREGISTEREXIT      *WRexxDeregisterExit=NULL;
WREXXQUERYEXIT           *WRexxQueryExit=NULL;
WREXXREGISTERSUBCOMEXE   *WRexxRegisterSubcomExe=NULL;
WREXXDEREGISTERSUBCOM    *WRexxDeregisterSubcom=NULL;
WREXXREGISTERSUBCOMDLL   *WRexxRegisterSubcomDll=NULL;
WREXXQUERYSUBCOM         *WRexxQuerySubcom=NULL;
WREXXREGISTERFUNCTIONEXE *WRexxRegisterFunctionExe=NULL;
WREXXREGISTERFUNCTIONDLL *WRexxRegisterFunctionDll=NULL;
WREXXDEREGISTERFUNCTION  *WRexxDeregisterFunction=NULL;
WREXXQUERYFUNCTION       *WRexxQueryFunction=NULL;
WREXXVARIABLEPOOL        *WRexxVariablePool=NULL;

/*
 * Typedefs for uni-REXX
 */
#define ORXXCDecl __cdecl
#define PSAASHVBLK PSHVBLOCK
typedef LONG ORXXCDecl   UREXXSTART(LONG,PRXSTRING,PSZ,PRXSTRING,PSZ,LONG,PRXSYSEXIT,PSHORT,PRXSTRING);
typedef APIRET ORXXCDecl UREXXREGISTEREXITDLL(PSZ,PSZ,PSZ,PUCHAR,ULONG);
typedef APIRET ORXXCDecl UREXXREGISTEREXITEXE(PSZ,PFN,PUCHAR);
typedef APIRET ORXXCDecl UREXXDEREGISTEREXIT(PSZ,PSZ);
typedef APIRET ORXXCDecl UREXXQUERYEXIT(PSZ,PSZ,PUSHORT,PUCHAR ) ;
typedef APIRET ORXXCDecl UREXXREGISTERSUBCOMDLL(PSZ,PSZ,PSZ,PUCHAR,ULONG);
typedef APIRET ORXXCDecl UREXXREGISTERSUBCOMEXE(PSZ,PFN,PUCHAR);
typedef APIRET ORXXCDecl UREXXQUERYSUBCOM(PSZ,PSZ,PUSHORT,PUCHAR);
typedef APIRET ORXXCDecl UREXXDEREGISTERSUBCOM(PSZ,PSZ);
typedef APIRET ORXXCDecl UREXXREGISTERFUNCTIONDLL(PSZ,PSZ,PSZ);
typedef APIRET ORXXCDecl UREXXREGISTERFUNCTIONEXE(PSZ,PFN);
typedef APIRET ORXXCDecl UREXXDEREGISTERFUNCTION(PSZ);
typedef APIRET ORXXCDecl UREXXQUERYFUNCTION(PSZ);
typedef APIRET ORXXCDecl UREXXVARIABLEPOOL(PSAASHVBLK);
UREXXSTART               *URexxStart=NULL;
UREXXREGISTEREXITEXE     *URexxRegisterExitExe=NULL;
UREXXREGISTEREXITDLL     *URexxRegisterExitDll=NULL;
UREXXDEREGISTEREXIT      *URexxDeregisterExit=NULL;
UREXXQUERYEXIT           *URexxQueryExit=NULL;
UREXXREGISTERSUBCOMEXE   *URexxRegisterSubcomExe=NULL;
UREXXDEREGISTERSUBCOM    *URexxDeregisterSubcom=NULL;
UREXXREGISTERSUBCOMDLL   *URexxRegisterSubcomDll=NULL;
UREXXQUERYSUBCOM         *URexxQuerySubcom=NULL;
UREXXREGISTERFUNCTIONEXE *URexxRegisterFunctionExe=NULL;
UREXXREGISTERFUNCTIONDLL *URexxRegisterFunctionDll=NULL;
UREXXDEREGISTERFUNCTION  *URexxDeregisterFunction=NULL;
UREXXQUERYFUNCTION       *URexxQueryFunction=NULL;
UREXXVARIABLEPOOL        *URexxVariablePool=NULL;

static char TraceFileName[256];
static int Trace = 0;
static char LoadedLibrary[256];
static int InterpreterIdx = -1;

static void TraceString( char *fmt, ... )
{
   FILE *fp=NULL;
   va_list argptr;

   fp = fopen( TraceFileName, "a" );
   if ( fp )
   {
      va_start( argptr, fmt );
      vfprintf( fp, fmt, argptr );
      va_end( argptr );
      fclose( fp );
   }
}

static handle_type FindInterpreter( char *library, int idx )
{
   handle_type handle=(handle_type)NULL ;
   handle_type handle1=(handle_type)NULL ;
   FARPROC addr;
   register int j=0;
   char *CurrentLibrary=NULL;

   handle = LoadLibrary( library ) ;
   if ( handle != NULL )
   {
      if ( idx == INT_OBJECT_REXX )  /* special kludge for Object Rexx */
      {
         handle1 = LoadLibrary( "REXXAPI" ) ;
         if ( handle1 == NULL )
         {
            fprintf( stderr, "Could not find REXXAPI Rexx DLL. Cannot continue.\n");
            exit( 9 );
         }
      }
      strcpy( LoadedLibrary, library );
      for ( j = 0; j < NUM_REXX_FUNCTIONS; j++ )
      {
         if ( idx == INT_OBJECT_REXX 
         &&   MyFunctionName[ j ].ObjectRexxAPI )
         {
            addr = GetProcAddress( (HMODULE)handle1, MyFunctionName[ j ].Name );
            CurrentLibrary = "REXXAPI";
         }
         else
         {
            addr = GetProcAddress( (HMODULE)handle, MyFunctionName[ j ].Name );
            CurrentLibrary = library;
         }
         /*
          * Log the function and address. This is useful if the module
          * doesn't have an address for this procedure.
          */
         if (Trace)
         {
            TraceString( "%s.DLL %s: Address %x\n",
               LoadedLibrary,
               MyFunctionName[ j ].Name,
               (addr == NULL) ? 0 : addr );
         }
         /*
          * Even if the function being processed is not in the module, its
          * address is still stored.  In this case it will simply be set
          * again to NULL.
          */
         switch( idx )
         {
            case INT_REGINA:
               switch ( j )
               {
                  case FUNCTION_REXXSTART: RRexxStart = (RREXXSTART*)addr; break;
                  case FUNCTION_REXXREGISTEREXITEXE: RRexxRegisterExitExe = (RREXXREGISTEREXITEXE*)addr; break;
                  case FUNCTION_REXXREGISTEREXITDLL: RRexxRegisterExitDll = (RREXXREGISTEREXITDLL*)addr; break;
                  case FUNCTION_REXXDEREGISTEREXIT:  RRexxDeregisterExit = (RREXXDEREGISTEREXIT*)addr; break;
                  case FUNCTION_REXXQUERYEXIT:       RRexxQueryExit = (RREXXQUERYEXIT*)addr; break;
                  case FUNCTION_REXXREGISTERSUBCOMEXE: RRexxRegisterSubcomExe = (RREXXREGISTERSUBCOMEXE*)addr; break;
                  case FUNCTION_REXXDEREGISTERSUBCOM: RRexxDeregisterSubcom = (RREXXDEREGISTERSUBCOM*)addr; break;
                  case FUNCTION_REXXREGISTERSUBCOMDLL: RRexxRegisterSubcomDll = (RREXXREGISTERSUBCOMDLL*)addr; break;
                  case FUNCTION_REXXQUERYSUBCOM: RRexxQuerySubcom = (RREXXQUERYSUBCOM*)addr; break;
                  case FUNCTION_REXXREGISTERFUNCTIONEXE: RRexxRegisterFunctionExe = (RREXXREGISTERFUNCTIONEXE*)addr; break;
                  case FUNCTION_REXXREGISTERFUNCTIONDLL: RRexxRegisterFunctionDll = (RREXXREGISTERFUNCTIONDLL*)addr; break;
                  case FUNCTION_REXXDEREGISTERFUNCTION:  RRexxDeregisterFunction = (RREXXDEREGISTERFUNCTION*)addr; break;
                  case FUNCTION_REXXQUERYFUNCTION: RRexxQueryFunction = (RREXXQUERYFUNCTION*)addr; break;
                  case FUNCTION_REXXVARIABLEPOOL: RRexxVariablePool = (RREXXVARIABLEPOOL*)addr; break;
               }
               break;
            case INT_OBJECT_REXX:
               switch ( j )
               {
                  case FUNCTION_REXXSTART: ORexxStart = (OREXXSTART*)addr; break;
                  case FUNCTION_REXXREGISTEREXITEXE: ORexxRegisterExitExe = (OREXXREGISTEREXITEXE*)addr; break;
                  case FUNCTION_REXXREGISTEREXITDLL: ORexxRegisterExitDll = (OREXXREGISTEREXITDLL*)addr; break;
                  case FUNCTION_REXXDEREGISTEREXIT:  ORexxDeregisterExit = (OREXXDEREGISTEREXIT*)addr; break;
                  case FUNCTION_REXXQUERYEXIT:       ORexxQueryExit = (OREXXQUERYEXIT*)addr; break;
                  case FUNCTION_REXXREGISTERSUBCOMEXE: ORexxRegisterSubcomExe = (OREXXREGISTERSUBCOMEXE*)addr; break;
                  case FUNCTION_REXXDEREGISTERSUBCOM: ORexxDeregisterSubcom = (OREXXDEREGISTERSUBCOM*)addr; break;
                  case FUNCTION_REXXREGISTERSUBCOMDLL: ORexxRegisterSubcomDll = (OREXXREGISTERSUBCOMDLL*)addr; break;
                  case FUNCTION_REXXQUERYSUBCOM: ORexxQuerySubcom = (OREXXQUERYSUBCOM*)addr; break;
                  case FUNCTION_REXXREGISTERFUNCTIONEXE: ORexxRegisterFunctionExe = (OREXXREGISTERFUNCTIONEXE*)addr; break;
                  case FUNCTION_REXXREGISTERFUNCTIONDLL: ORexxRegisterFunctionDll = (OREXXREGISTERFUNCTIONDLL*)addr; break;
                  case FUNCTION_REXXDEREGISTERFUNCTION:  ORexxDeregisterFunction = (OREXXDEREGISTERFUNCTION*)addr; break;
                  case FUNCTION_REXXQUERYFUNCTION: ORexxQueryFunction = (OREXXQUERYFUNCTION*)addr; break;
                  case FUNCTION_REXXVARIABLEPOOL: ORexxVariablePool = (OREXXVARIABLEPOOL*)addr; break;
               }
               break;
            case INT_PERSONAL_REXX:
               switch ( j )
               {
                  case FUNCTION_REXXSTART: QRexxStart = (QREXXSTART*)addr; break;
                  case FUNCTION_REXXREGISTEREXITEXE: QRexxRegisterExitExe = (QREXXREGISTEREXITEXE*)addr; break;
                  case FUNCTION_REXXREGISTEREXITDLL: QRexxRegisterExitDll = (QREXXREGISTEREXITDLL*)addr; break;
                  case FUNCTION_REXXDEREGISTEREXIT:  QRexxDeregisterExit = (QREXXDEREGISTEREXIT*)addr; break;
                  case FUNCTION_REXXQUERYEXIT:       QRexxQueryExit = (QREXXQUERYEXIT*)addr; break;
                  case FUNCTION_REXXREGISTERSUBCOMEXE: QRexxRegisterSubcomExe = (QREXXREGISTERSUBCOMEXE*)addr; break;
                  case FUNCTION_REXXDEREGISTERSUBCOM: QRexxDeregisterSubcom = (QREXXDEREGISTERSUBCOM*)addr; break;
                  case FUNCTION_REXXREGISTERSUBCOMDLL: QRexxRegisterSubcomDll = (QREXXREGISTERSUBCOMDLL*)addr; break;
                  case FUNCTION_REXXQUERYSUBCOM: QRexxQuerySubcom = (QREXXQUERYSUBCOM*)addr; break;
                  case FUNCTION_REXXREGISTERFUNCTIONEXE: QRexxRegisterFunctionExe = (QREXXREGISTERFUNCTIONEXE*)addr; break;
                  case FUNCTION_REXXREGISTERFUNCTIONDLL: QRexxRegisterFunctionDll = (QREXXREGISTERFUNCTIONDLL*)addr; break;
                  case FUNCTION_REXXDEREGISTERFUNCTION:  QRexxDeregisterFunction = (QREXXDEREGISTERFUNCTION*)addr; break;
                  case FUNCTION_REXXQUERYFUNCTION: QRexxQueryFunction = (QREXXQUERYFUNCTION*)addr; break;
                  case FUNCTION_REXXVARIABLEPOOL: QRexxVariablePool = (QREXXVARIABLEPOOL*)addr; break;
               }
               break;
            case INT_WINREXX:
               switch ( j )
               {
                  case FUNCTION_REXXSTART: WRexxStart = (WREXXSTART*)addr; break;
                  case FUNCTION_REXXREGISTEREXITEXE: WRexxRegisterExitExe = (WREXXREGISTEREXITEXE*)addr; break;
                  case FUNCTION_REXXREGISTEREXITDLL: WRexxRegisterExitDll = (WREXXREGISTEREXITDLL*)addr; break;
                  case FUNCTION_REXXDEREGISTEREXIT:  WRexxDeregisterExit = (WREXXDEREGISTEREXIT*)addr; break;
                  case FUNCTION_REXXQUERYEXIT:       WRexxQueryExit = (WREXXQUERYEXIT*)addr; break;
                  case FUNCTION_REXXREGISTERSUBCOMEXE: WRexxRegisterSubcomExe = (WREXXREGISTERSUBCOMEXE*)addr; break;
                  case FUNCTION_REXXDEREGISTERSUBCOM: WRexxDeregisterSubcom = (WREXXDEREGISTERSUBCOM*)addr; break;
                  case FUNCTION_REXXREGISTERSUBCOMDLL: WRexxRegisterSubcomDll = (WREXXREGISTERSUBCOMDLL*)addr; break;
                  case FUNCTION_REXXQUERYSUBCOM: WRexxQuerySubcom = (WREXXQUERYSUBCOM*)addr; break;
                  case FUNCTION_REXXREGISTERFUNCTIONEXE: WRexxRegisterFunctionExe = (WREXXREGISTERFUNCTIONEXE*)addr; break;
                  case FUNCTION_REXXREGISTERFUNCTIONDLL: WRexxRegisterFunctionDll = (WREXXREGISTERFUNCTIONDLL*)addr; break;
                  case FUNCTION_REXXDEREGISTERFUNCTION:  WRexxDeregisterFunction = (WREXXDEREGISTERFUNCTION*)addr; break;
                  case FUNCTION_REXXQUERYFUNCTION: WRexxQueryFunction = (WREXXQUERYFUNCTION*)addr; break;
                  case FUNCTION_REXXVARIABLEPOOL: WRexxVariablePool = (WREXXVARIABLEPOOL*)addr; break;
               }
               break;
            case INT_UNI_REXX:
               switch ( j )
               {
                  case FUNCTION_REXXSTART: URexxStart = (UREXXSTART*)addr; break;
                  case FUNCTION_REXXREGISTEREXITEXE: URexxRegisterExitExe = (UREXXREGISTEREXITEXE*)addr; break;
                  case FUNCTION_REXXREGISTEREXITDLL: URexxRegisterExitDll = (UREXXREGISTEREXITDLL*)addr; break;
                  case FUNCTION_REXXDEREGISTEREXIT:  URexxDeregisterExit = (UREXXDEREGISTEREXIT*)addr; break;
                  case FUNCTION_REXXQUERYEXIT:       URexxQueryExit = (UREXXQUERYEXIT*)addr; break;
                  case FUNCTION_REXXREGISTERSUBCOMEXE: URexxRegisterSubcomExe = (UREXXREGISTERSUBCOMEXE*)addr; break;
                  case FUNCTION_REXXDEREGISTERSUBCOM: URexxDeregisterSubcom = (UREXXDEREGISTERSUBCOM*)addr; break;
                  case FUNCTION_REXXREGISTERSUBCOMDLL: URexxRegisterSubcomDll = (UREXXREGISTERSUBCOMDLL*)addr; break;
                  case FUNCTION_REXXQUERYSUBCOM: URexxQuerySubcom = (UREXXQUERYSUBCOM*)addr; break;
                  case FUNCTION_REXXREGISTERFUNCTIONEXE: URexxRegisterFunctionExe = (UREXXREGISTERFUNCTIONEXE*)addr; break;
                  case FUNCTION_REXXREGISTERFUNCTIONDLL: URexxRegisterFunctionDll = (UREXXREGISTERFUNCTIONDLL*)addr; break;
                  case FUNCTION_REXXDEREGISTERFUNCTION:  URexxDeregisterFunction = (UREXXDEREGISTERFUNCTION*)addr; break;
                  case FUNCTION_REXXQUERYFUNCTION: URexxQueryFunction = (UREXXQUERYFUNCTION*)addr; break;
                  case FUNCTION_REXXVARIABLEPOOL: URexxVariablePool = (UREXXVARIABLEPOOL*)addr; break;
               }
               break;
         }
      }
   }
   return handle;
}

static void LoadInterpreter( void )
{
   handle_type handle=(handle_type)NULL ;
   register int i=0;
   char Preference[256];

   GetPrivateProfileString( "TRACE", "FileName", "*", TraceFileName, 255, "rexxtrans.ini" );
   if ( strcmp( TraceFileName, "*" ) != 0)
   {
      Trace = 1;
   }
   strcpy( LoadedLibrary, "" );
   GetPrivateProfileString( "INTERPRETER", "Use", "*", Preference, 255, "rexxtrans.ini" );
   if ( strcmp( Preference, "*" ) == 0)
   {
      for ( i = 0; MyLibraryName[ i ] != NULL; i++ )
      {
         if ( ( handle = FindInterpreter( MyLibraryName[ i ], i ) ) != NULL )
         {
            InterpreterIdx = i;
            break;
         }
      }
      if ( handle == NULL )
      {
/*         fprintf( stderr, "Could not find any Rexx DLL. Cannot continue.\n" ); */
/*         exit( 11 ); MH */
      }
   }
   else
   {
      for ( i = 0; MyLibraryName[ i ] != NULL; i++ )
      {
         if ( strcmp( Preference, MyLibraryName[ i ] ) == 0 )
         {
            InterpreterIdx = i;
         }
      }
      if ( InterpreterIdx == (-1) )
      {
         fprintf( stderr, "Don't know how to handle %s Rexx DLL specified in REXXTRANS.INI. Cannot continue.\n",
            Preference );
         exit( 12 );
      }
      else
      {
         if ( FindInterpreter( Preference, InterpreterIdx ) == NULL )
         {
            fprintf( stderr, "Could not find %s Rexx DLL specified in REXXTRANS.INI. Cannot continue.\n",
               Preference );
            exit( 13 );
         }
      }
   }
   return;
}

static void FreeInterpreter( void )
{
   if (strcmp( LoadedLibrary, "" ) == 0 )
      return;
   FreeLibrary( GetModuleHandle( LoadedLibrary ) );
   if ( InterpreterIdx == INT_OBJECT_REXX )
      FreeLibrary( GetModuleHandle( "REXXAPI" ) );
   return;
}


/*
 * RexxStart
 */
APIRET APIENTRY RexxStart(
   LONG ArgCount,
   PRXSTRING ArgList,
   PSZ ProgramName,
   PRXSTRING Instore,
   PSZ EnvName,
   LONG CallType,
   PRXSYSEXIT Exits,
   PSHORT ReturnCode,
   PRXSTRING Result )
{
   APIRET rc=RXFUNC_NOTREG;
   if (Trace)
   {
      TraceString( "%s.DLL %s: ArgCount %d ArgList %x ProgramName %s Instore %x EnvName %s Calltype %d Exits %x ReturnCode %x Result %x - expand it",
         MyLibraryName[ InterpreterIdx ],
         "RexxStart()",
         ArgCount,
         ArgList,
         ProgramName,
         Instore,
         EnvName,
         CallType,
         Exits,
         ReturnCode,
         Result );
   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxStart)
            rc = (*RRexxStart)(
               (LONG)      ArgCount,
               (PRXSTRING) ArgList,
               (PSZ)       ProgramName,
               (PRXSTRING) Instore,
               (PSZ)       EnvName,
               (LONG)      CallType,
               (PRXSYSEXIT)Exits,
               (PSHORT)    ReturnCode,
               (PRXSTRING) Result ) ;
         break;
      case INT_OBJECT_REXX:
         if (ORexxStart)
            rc = (*ORexxStart)(
               (LONG)      ArgCount,
               (PRXSTRING) ArgList,
               (PSZ)       ProgramName,
               (PRXSTRING) Instore,
               (PSZ)       EnvName,
               (LONG)      CallType,
               (PRXSYSEXIT)Exits,
               (PSHORT)    ReturnCode,
               (PRXSTRING) Result ) ;
         break;
      case INT_PERSONAL_REXX:
         if (QRexxStart)
            rc = (*QRexxStart)(
               (int)       ArgCount,
               (PRXSTRING) ArgList,
               (LPCSTR)    ProgramName,
               (PRXSTRING) Instore,
               (LPCSTR)    EnvName,
               (int)       CallType,
               (PRXSYSEXIT)Exits,
               (LPSHORT)   ReturnCode,
               (PRXSTRING) Result ) ;
         break;
      case INT_WINREXX:
         if (WRexxStart)
            rc = (*WRexxStart)(
               (int)       ArgCount,
               (PRXSTRING) ArgList,
               (LPCSTR)    ProgramName,
               (PRXSTRING) Instore,
               (LPCSTR)    EnvName,
               (int)       CallType,
               (PRXSYSEXIT)Exits,
               (LPSHORT)   ReturnCode,
               (PRXSTRING) Result ) ;
         break;
      case INT_UNI_REXX:
         if (URexxStart)
            rc = (*URexxStart)(
               (LONG)      ArgCount,
               (PRXSTRING) ArgList,
               (PSZ)       ProgramName,
               (PRXSTRING) Instore,
               (PSZ)       EnvName,
               (LONG)      CallType,
               (PRXSYSEXIT)Exits,
               (PSHORT)    ReturnCode,
               (PRXSTRING) Result ) ;
         break;
   }
   if (Trace)
   {
      TraceString( ": Result: %d\n", rc );
   }
   return rc;
}

/*
 * Variable pool
 */
APIRET APIENTRY RexxVariablePool(
   PSHVBLOCK RequestBlockList )
{
   APIRET rc=RXSHV_NOAVL;

   if (Trace)
   {
      PSHVBLOCK tmp=RequestBlockList;
      TraceString( "%s.DLL %s: RequestBlockList %x\n",
         MyLibraryName[ InterpreterIdx ],
         "RexxVariablePool()",
         RequestBlockList );
      while(tmp)
      {
         switch( tmp->shvcode )
         {
            case RXSHV_SET: 
               TraceString("in    RXSHV_SET: shvname: \"%s\" shvnamelen: %d shvvalue: \"%s\" shvvaluelen: %d\n",
                  tmp->shvname.strptr, tmp->shvnamelen, tmp->shvvalue.strptr, tmp->shvvaluelen );
               break;
            case RXSHV_SYSET:
               TraceString("in  RXSHV_SYSET: shvname: \"%s\" shvnamelen: %d shvvalue: \"%s\" shvvaluelen: %d\n",
                  tmp->shvname.strptr, tmp->shvnamelen, tmp->shvvalue.strptr, tmp->shvvaluelen );
               break;
            case RXSHV_FETCH:
               TraceString("in  RXSHV_FETCH: shvname: \"%s\" shvnamelen: %d\n",
                  tmp->shvname.strptr, tmp->shvnamelen );
               break;
            case RXSHV_DROPV:
               TraceString("in  RXSHV_DROPV: shvname: \"%s\" shvnamelen: %d\n",
                  tmp->shvname.strptr, tmp->shvnamelen );
               break;
            case RXSHV_SYDRO:
               TraceString("in  RXSHV_SYDRO: shvname: \"%s\" shvnamelen: %d\n",
                  tmp->shvname.strptr, tmp->shvnamelen );
               break;
            case RXSHV_NEXTV:
               TraceString("in  RXSHV_NEXTV: shvname: \"%s\" shvnamelen: %d\n",
                  tmp->shvname.strptr, tmp->shvnamelen );
               break;
            case RXSHV_PRIV:
               TraceString("in   RXSHV_PRIV\n" );
               break;
            case RXSHV_EXIT:
               TraceString("in   RXSHV_EXIT\n" );
               break;
            default:
               break;
         }
         tmp = tmp->shvnext;
      }
   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxVariablePool)
            rc = (*RRexxVariablePool)(
               (PSHVBLOCK) RequestBlockList);
         break;
      case INT_OBJECT_REXX:
         if (ORexxVariablePool)
            rc = (*ORexxVariablePool)(
               (PSHVBLOCK) RequestBlockList);
         break;
      case INT_PERSONAL_REXX:
         if (QRexxVariablePool)
            rc = (*QRexxVariablePool)(
               (PSHVBLOCK) RequestBlockList);
         break;
      case INT_WINREXX:
         if (WRexxVariablePool)
            rc = (*WRexxVariablePool)(
               (PSHVBLOCK) RequestBlockList);
         break;
      case INT_UNI_REXX:
         if (URexxVariablePool)
            rc = (*URexxVariablePool)(
               (PSAASHVBLK) RequestBlockList);
         break;
   }
   if (Trace)
   {
      PSHVBLOCK tmp=RequestBlockList;
      while(tmp)
      {
         switch( tmp->shvcode )
         {
            case RXSHV_SET: 
               TraceString("out   RXSHV_SET: shvret: %x\n",
                  tmp->shvret );
               break;
            case RXSHV_SYSET:
               TraceString("out RXSHV_SYSET: shvret: %x\n",
                  tmp->shvret );
               break;
            case RXSHV_FETCH:
               TraceString("out RXSHV_FETCH: shvret: %x shvvalue: \"%s\" shvvaluelen: %d\n",
                  tmp->shvret, tmp->shvvalue.strptr, tmp->shvvaluelen );
               break;
            case RXSHV_DROPV:
               TraceString("out RXSHV_DROPV: shvret: %x\n",
                  tmp->shvret );
               break;
            case RXSHV_SYDRO:
               TraceString("out RXSHV_SYDRO: shvret: %x\n",
                  tmp->shvret );
               break;
            case RXSHV_NEXTV:
               TraceString("out RXSHV_NEXTV: shvret: %x\n",
                  tmp->shvret );
               break;
            case RXSHV_PRIV:
               TraceString("out  RXSHV_PRIV: shvret: %x\n",
                  tmp->shvret );
               break;
            case RXSHV_EXIT:
               TraceString("out  RXSHV_EXIT: shvret: %x\n",
                  tmp->shvret );
               break;
            default:
               break;
         }
         tmp = tmp->shvnext;
      }
      TraceString( ": Result: %d\n", rc );
   }
   return rc;
}

/*
 * System Exit functions
 */
APIRET APIENTRY RexxRegisterExitExe(
   PSZ EnvName,
   PFN EntryPoint, 
   PUCHAR UserArea )
{
   if (Trace)
   {
      TraceString( "%s.DLL %s: EnvName %s EntryPoint %x UserArea %x\n",
         MyLibraryName[ InterpreterIdx ],
         "RexxRegisterExitExe()",
         EnvName,
         EntryPoint,
         UserArea );
   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxRegisterExitExe)
            return (*RRexxRegisterExitExe)(
               (PSZ)       EnvName,
               (PFN)       EntryPoint,
               (PUCHAR)    UserArea );
         break;
      case INT_OBJECT_REXX:
         if (ORexxRegisterExitExe)
            return (*ORexxRegisterExitExe)(
               (PSZ)       EnvName,
               (PFN)       EntryPoint,
               (PUCHAR)    UserArea );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxRegisterExitExe)
            return (*QRexxRegisterExitExe)(
               (LPCSTR)    EnvName,
               (FARPROC)   EntryPoint,
               (LPBYTE)    UserArea );
         break;
      case INT_WINREXX:
         if (WRexxRegisterExitExe)
            return (*WRexxRegisterExitExe)(
               (LPCSTR)    EnvName,
               (FARPROC)   EntryPoint,
               (LPBYTE)    UserArea );
         break;
      case INT_UNI_REXX:
         if (URexxRegisterExitExe)
            return (*URexxRegisterExitExe)(
               (PSZ)       EnvName,
               (PFN)       EntryPoint,
               (PUCHAR)    UserArea );
         break;
   }
   return RXEXIT_NOTREG;
}

APIRET APIENTRY RexxRegisterExitDll(
   PSZ EnvName,
   PSZ ModuleName,
   PSZ ProcedureName,
   PUCHAR UserArea,
   ULONG DropAuth )
{
   if (Trace)
   {
      TraceString( "%s.DLL %s: EnvName %s ModuleName %s ProcedureName %s UserArea %x DropAuth %d\n",
         MyLibraryName[ InterpreterIdx ],
         "RexxRegisterExitDll()",
         EnvName,
         ModuleName,
         ProcedureName,
         UserArea,
         DropAuth );
   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxRegisterExitDll)
            return (*RRexxRegisterExitDll)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName,
               (PSZ)       ProcedureName,
               (PUCHAR)    UserArea,
               (ULONG)     DropAuth );
         break;
      case INT_OBJECT_REXX:
         if (ORexxRegisterExitDll)
            return (*ORexxRegisterExitDll)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName,
               (PSZ)       ProcedureName,
               (PUCHAR)    UserArea,
               (ULONG)     DropAuth );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxRegisterExitDll)
            return (*QRexxRegisterExitDll)(
               (LPCSTR)    EnvName,
               (LPCSTR)    ModuleName,
               (LPCSTR)    ProcedureName,
               (LPBYTE)    UserArea,
               (UINT)      DropAuth );
         break;
      case INT_WINREXX:
         if (WRexxRegisterExitDll)
            return (*WRexxRegisterExitDll)(
               (LPCSTR)    EnvName,
               (LPCSTR)    ModuleName,
               (LPCSTR)    ProcedureName,
               (LPBYTE)    UserArea,
               (UINT)      DropAuth );
         break;
      case INT_UNI_REXX:
         if (URexxRegisterExitDll)
            return (*URexxRegisterExitDll)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName,
               (PSZ)       ProcedureName,
               (PUCHAR)    UserArea,
               (ULONG)     DropAuth );
         break;
   }
   return RXEXIT_NOTREG;
}

APIRET APIENTRY RexxDeregisterExit(
   PSZ EnvName,
   PSZ ModuleName )
{
   if (Trace)
   {
      TraceString( "%s.DLL %s: EnvName %s ModuleName %s\n",
         MyLibraryName[ InterpreterIdx ],
         "RexxRegisterSubcomDll()",
         EnvName,
         (ModuleName == NULL) ? "NULL" : ModuleName );
   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxDeregisterExit)
            return (*RRexxDeregisterExit)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName );
         break;
      case INT_OBJECT_REXX:
         if (ORexxDeregisterExit)
            return (*ORexxDeregisterExit)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxDeregisterExit)
            return (*QRexxDeregisterExit)(
               (LPCSTR)    EnvName,
               (LPCSTR)    ModuleName );
         break;
      case INT_WINREXX:
         if (WRexxDeregisterExit)
            return (*WRexxDeregisterExit)(
               (LPCSTR)    EnvName,
               (LPCSTR)    ModuleName );
         break;
      case INT_UNI_REXX:
         if (URexxDeregisterExit)
            return (*URexxDeregisterExit)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName );
         break;
   }
   return RXEXIT_NOTREG;
}

APIRET APIENTRY RexxQueryExit(
   PSZ EnvName,
   PSZ ModuleName,
   PUSHORT Flag,
   PUCHAR UserArea )
{
   if (Trace)
   {
      TraceString( "%s.DLL %s: EnvName %s ModuleName %s Flag %d UserArea %x\n",
         MyLibraryName[ InterpreterIdx ],
         "RexxRegisterSubcomDll()",
         EnvName,
         ModuleName,
         Flag,
         UserArea );
   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxQueryExit)
            return (*RRexxQueryExit)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName,
               (PUSHORT)   Flag,
               (PUCHAR)    UserArea ) ;
         break;
      case INT_OBJECT_REXX:
         if (ORexxQueryExit)
            return (*ORexxQueryExit)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName,
               (PUSHORT)   Flag,
               (PUCHAR)    UserArea ) ;
         break;
      case INT_PERSONAL_REXX:
         if (QRexxQueryExit)
            return (*QRexxQueryExit)(
               (LPCSTR)    EnvName,
               (LPCSTR)    ModuleName,
               (LPWORD)    Flag,
               (LPBYTE)    UserArea ) ;
         break;
      case INT_WINREXX:
         if (WRexxQueryExit)
            return (*WRexxQueryExit)(
               (LPCSTR)    EnvName,
               (LPCSTR)    ModuleName,
               (LPWORD)    Flag,
               (LPBYTE)    UserArea ) ;
         break;
      case INT_UNI_REXX:
         if (URexxQueryExit)
            return (*URexxQueryExit)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName,
               (PUSHORT)   Flag,
               (PUCHAR)    UserArea ) ;
         break;
   }
   return RXEXIT_NOTREG;
}

/*
 * Subcommands
 */
APIRET APIENTRY RexxRegisterSubcomExe(
   PSZ EnvName,
   PFN EntryPoint,
   PUCHAR UserArea )
{
   if (Trace)
   {
      TraceString( "%s.DLL %s: EnvName %s EntryPoint %x UserArea %x\n",
         MyLibraryName[ InterpreterIdx ],
         "RexxRegisterSubcomExe()",
         EnvName,
         EntryPoint,
         UserArea );
   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxRegisterSubcomExe)
            return (*RRexxRegisterSubcomExe)(
               (PSZ)       EnvName,
               (PFN)       EntryPoint,
               (PUCHAR)    UserArea );
         break;
      case INT_OBJECT_REXX:
         if (ORexxRegisterSubcomExe)
            return (*ORexxRegisterSubcomExe)(
               (PSZ)       EnvName,
               (PFN)       EntryPoint,
               (PUCHAR)    UserArea );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxRegisterSubcomExe)
            return (*QRexxRegisterSubcomExe)(
               (LPCSTR)    EnvName,
               (FARPROC)   EntryPoint,
               (LPBYTE)    UserArea );
         break;
      case INT_WINREXX:
         if (WRexxRegisterSubcomExe)
            return (*WRexxRegisterSubcomExe)(
               (LPCSTR)    EnvName,
               (FARPROC)   EntryPoint,
               (LPBYTE)    UserArea );
         break;
      case INT_UNI_REXX:
         if (URexxRegisterSubcomExe)
            return (*URexxRegisterSubcomExe)(
               (PSZ)       EnvName,
               (PFN)       EntryPoint,
               (PUCHAR)    UserArea );
         break;
   }
   return RXSUBCOM_NOTREG;
}

APIRET APIENTRY RexxDeregisterSubcom(
   PSZ EnvName,
   PSZ ModuleName )
{
   if (Trace)
   {
      TraceString( "%s.DLL %s: EnvName %s ModuleName %s\n",
         MyLibraryName[ InterpreterIdx ],
         "RexxDeregisterSubcom()",
         EnvName,
         (ModuleName == NULL) ? "NULL" : ModuleName );
   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxDeregisterSubcom)
            return (*RRexxDeregisterSubcom)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName );
         break;
      case INT_OBJECT_REXX:
         if (ORexxDeregisterSubcom)
            return (*ORexxDeregisterSubcom)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxDeregisterSubcom)
            return (*QRexxDeregisterSubcom)(
               (LPCSTR)    EnvName,
               (LPCSTR)    ModuleName );
         break;
      case INT_WINREXX:
         if (WRexxDeregisterSubcom)
            return (*WRexxDeregisterSubcom)(
               (LPCSTR)    EnvName,
               (LPCSTR)    ModuleName );
         break;
      case INT_UNI_REXX:
         if (URexxDeregisterSubcom)
            return (*URexxDeregisterSubcom)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName );
         break;
   }
   return RXSUBCOM_NOTREG;
}

APIRET APIENTRY RexxRegisterSubcomDll(
   PSZ EnvName,
   PSZ ModuleName,
   PSZ ProcedureName,
   PUCHAR UserArea,
   ULONG DropAuth )
{
   if (Trace)
   {
      TraceString( "%s.DLL %s: EnvName %s ModuleName %s ProcedureName %s UserArea %x DropAuth %d\n",
         MyLibraryName[ InterpreterIdx ],
         "RexxQuerySubcom()",
         EnvName,
         ModuleName,
         ProcedureName,
         UserArea,
         DropAuth );
   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxRegisterSubcomDll)
            return (*RRexxRegisterSubcomDll)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName,
               (PSZ)       ProcedureName,
               (PUCHAR)    UserArea,
               (ULONG)     DropAuth );
         break;
      case INT_OBJECT_REXX:
         if (ORexxRegisterSubcomDll)
            return (*ORexxRegisterSubcomDll)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName,
               (PSZ)       ProcedureName,
               (PUCHAR)    UserArea,
               (ULONG)     DropAuth );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxRegisterSubcomDll)
            return (*QRexxRegisterSubcomDll)(
               (LPCSTR)    EnvName,
               (LPCSTR)    ModuleName,
               (LPCSTR)    ProcedureName,
               (LPBYTE)    UserArea,
               (UINT)      DropAuth );
         break;
      case INT_WINREXX:
         if (WRexxRegisterSubcomDll)
            return (*WRexxRegisterSubcomDll)(
               (LPCSTR)    EnvName,
               (LPCSTR)    ModuleName,
               (LPCSTR)    ProcedureName,
               (LPBYTE)    UserArea,
               (UINT)      DropAuth );
         break;
      case INT_UNI_REXX:
         if (URexxRegisterSubcomDll)
            return (*URexxRegisterSubcomDll)(
               (PSZ)       EnvName,
               (PSZ)       ModuleName,
               (PSZ)       ProcedureName,
               (PUCHAR)    UserArea,
               (ULONG)     DropAuth );
         break;
   }
   return RXSUBCOM_NOTREG;
}

APIRET APIENTRY RexxQuerySubcom(
   PSZ Envname,
   PSZ ModuleName,
   PUSHORT Flag,
   PUCHAR UserArea )
{
   if (Trace)
   {
      TraceString( "%s.DLL %s: EnvName %s ModuleName %s Flag %d UserArea %x\n",
         MyLibraryName[ InterpreterIdx ],
         "RexxQuerySubcom()",
         Envname,
         ModuleName,
         Flag,
         UserArea );
   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxQuerySubcom)
            return (*RRexxQuerySubcom)(
               (PSZ)       Envname,
               (PSZ)       ModuleName,
               (PUSHORT)   Flag,
               (PUCHAR)    UserArea );
         break;
      case INT_OBJECT_REXX:
         if (ORexxQuerySubcom)
            return (*ORexxQuerySubcom)(
               (PSZ)       Envname,
               (PSZ)       ModuleName,
               (PUSHORT)   Flag,
               (PUCHAR)    UserArea );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxQuerySubcom)
            return (*QRexxQuerySubcom)(
               (LPCSTR)    Envname,
               (LPCSTR)    ModuleName,
               (LPWORD)    Flag,
               (LPBYTE)    UserArea );
         break;
      case INT_WINREXX:
         if (WRexxQuerySubcom)
            return (*WRexxQuerySubcom)(
               (LPCSTR)    Envname,
               (LPCSTR)    ModuleName,
               (LPWORD)    Flag,
               (LPBYTE)    UserArea );
         break;
      case INT_UNI_REXX:
         if (URexxQuerySubcom)
            return (*URexxQuerySubcom)(
               (PSZ)       Envname,
               (PSZ)       ModuleName,
               (PUSHORT)   Flag,
               (PUCHAR)    UserArea );
         break;
   }
   return RXSUBCOM_NOTREG;
}

/*
 * External functions
 */
APIRET APIENTRY RexxRegisterFunctionExe(
   PSZ name,
   PFN EntryPoint )
{
   APIRET rc=RXFUNC_NOTREG;

   if (Trace)
   {
      TraceString( "%s.DLL %s: Name %s Entrypoint %x",
         MyLibraryName[ InterpreterIdx ],
         "RexxRegisterFunctionExe()",
         name,
         EntryPoint );

   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxRegisterFunctionExe)
            rc = (*RRexxRegisterFunctionExe)(
               (PSZ)       name,
               (PFN)       EntryPoint );
         break;
      case INT_OBJECT_REXX:
         if (ORexxRegisterFunctionExe)
            rc = (*ORexxRegisterFunctionExe)(
               (PSZ)       name,
               (PFN)       EntryPoint );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxRegisterFunctionExe)
            rc = (*QRexxRegisterFunctionExe)(
               (LPCSTR)    name,
               (FARPROC)   EntryPoint );
         break;
      case INT_WINREXX:
         if (WRexxRegisterFunctionExe)
            rc = (*WRexxRegisterFunctionExe)(
               (LPCSTR)    name,
               (FARPROC)   EntryPoint );
         break;
      case INT_UNI_REXX:
         if (URexxRegisterFunctionExe)
            rc = (*URexxRegisterFunctionExe)(
               (PSZ)       name,
               (PFN)       EntryPoint );
         break;
   }
   if (Trace)
   {
      TraceString( ": Result: %d\n", rc );
   }
   return rc;
}

APIRET APIENTRY RexxRegisterFunctionDll(
   PSZ ExternalName,
   PSZ LibraryName,
   PSZ InternalName )
{
   APIRET rc=RXFUNC_NOTREG;

   if (Trace)
   {
      TraceString( "%s.DLL %s: External %s Library %s Internal %s",
         MyLibraryName[ InterpreterIdx ],
         "RexxRegisterFunctionDll()",
         ExternalName,
         LibraryName,
         InternalName );

   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxRegisterFunctionDll)
            rc = (*RRexxRegisterFunctionDll)(
               (PSZ)       ExternalName,
               (PSZ)       LibraryName,
               (PSZ)       InternalName );
         break;
      case INT_OBJECT_REXX:
         if (ORexxRegisterFunctionDll)
            rc = (*ORexxRegisterFunctionDll)(
               (PSZ)       ExternalName,
               (PSZ)       LibraryName,
               (PSZ)       InternalName );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxRegisterFunctionDll)
            rc = (*QRexxRegisterFunctionDll)(
               (LPCSTR)    ExternalName,
               (LPCSTR)    LibraryName,
               (LPCSTR)    InternalName );
         break;
      case INT_WINREXX:
         if (WRexxRegisterFunctionDll)
            rc = (*WRexxRegisterFunctionDll)(
               (LPCSTR)    ExternalName,
               (LPCSTR)    LibraryName,
               (LPCSTR)    InternalName );
         break;
      case INT_UNI_REXX:
         if (URexxRegisterFunctionDll)
            rc = (*URexxRegisterFunctionDll)(
               (PSZ)       ExternalName,
               (PSZ)       LibraryName,
               (PSZ)       InternalName );
         break;
   }
   if (Trace)
   {
      TraceString( ": Result: %d\n", rc );
   }
   return rc;
}

APIRET APIENTRY RexxDeregisterFunction(
   PSZ name )
{
   APIRET rc=RXFUNC_NOTREG;

   if (Trace)
   {
      TraceString( "%s.DLL %s: %s\n",
         MyLibraryName[ InterpreterIdx ],
         "RexxDeregisterFunction()",
         name );

   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxDeregisterFunction)
            rc = (*RRexxDeregisterFunction)(
               (PSZ)       name );
         break;
      case INT_OBJECT_REXX:
         if (ORexxDeregisterFunction)
            rc = (*ORexxDeregisterFunction)(
               (PSZ)       name );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxDeregisterFunction)
            rc = (*QRexxDeregisterFunction)(
               (LPCSTR)    name );
         break;
      case INT_WINREXX:
         if (WRexxDeregisterFunction)
            rc = (*WRexxDeregisterFunction)(
               (LPCSTR)    name );
         break;
      case INT_UNI_REXX:
         if (URexxDeregisterFunction)
            rc = (*URexxDeregisterFunction)(
               (PSZ)       name );
         break;
   }
   if (Trace)
   {
      TraceString( ": Result: %d\n", rc );
   }
   return rc;
}

APIRET APIENTRY RexxQueryFunction(
   PSZ name )
{
   APIRET rc=RXFUNC_NOTREG;

   if (Trace)
   {
      TraceString( "%s.DLL %s: %s",
         MyLibraryName[ InterpreterIdx ],
         "RexxQueryFunction()",
         name );

   }
   switch( InterpreterIdx )
   {
      case INT_REGINA:
         if (RRexxQueryFunction)
            rc = (*RRexxQueryFunction)(
               (PSZ)       name );
         break;
      case INT_OBJECT_REXX:
         if (ORexxQueryFunction)
            rc = (*ORexxQueryFunction)(
               (PSZ)       name );
         break;
      case INT_PERSONAL_REXX:
         if (QRexxQueryFunction)
            rc = (*QRexxQueryFunction)(
               (LPCSTR)    name );
         break;
      case INT_WINREXX:
         if (WRexxQueryFunction)
            rc = (*WRexxQueryFunction)(
               (LPCSTR)    name );
         break;
      case INT_UNI_REXX:
         if (URexxQueryFunction)
            rc = (*URexxQueryFunction)(
               (PSZ)       name );
         break;
   }
   if (Trace)
   {
      TraceString( ": Result: %d\n", rc );
   }
   return rc;
}



BOOL WINAPI DllMain( HINSTANCE hDLL, DWORD dwReason, LPVOID pReserved)
{
   switch( dwReason)
   {
      case DLL_PROCESS_ATTACH:
         LoadInterpreter( );
         break;
      case DLL_PROCESS_DETACH:
         FreeInterpreter( );
         break;
      case DLL_THREAD_ATTACH:
         break;
      case DLL_THREAD_DETACH:
         break;
   }
   return(TRUE);
}

int GetInterpreter( void )
{
 return InterpreterIdx ;
}
